diff -Naur openssl-1.0.0q.orig/crypto/sha/sha.h openssl-1.0.0q/crypto/sha/sha.h
--- openssl-1.0.0q.orig/crypto/sha/sha.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha.h	2017-04-25 16:23:40.665625097 +0200
@@ -130,7 +130,7 @@
 	{
 	SHA_LONG h[8];
 	SHA_LONG Nl,Nh;
-	SHA_LONG data[SHA_LBLOCK];
+	SHA_LONG data[SHA_LBLOCK];	/* ARRAY OK 2009-05-25 yngve */
 	unsigned int num,md_len;
 	} SHA256_CTX;
 
@@ -158,7 +158,7 @@
 #define SHA512_CBLOCK	(SHA_LBLOCK*8)	/* SHA-512 treats input data as a
 					 * contiguous array of 64 bit
 					 * wide big-endian values. */
-#if (defined(_WIN32) || defined(_WIN64)) && !defined(__MINGW32__)
+#if (defined(_WIN32) || defined(_WIN64)) && !defined(__MINGW32__) && !defined(EPOC)
 #define SHA_LONG64 unsigned __int64
 #define U64(C)     C##UI64
 #elif defined(__arch64__)
@@ -171,11 +171,11 @@
 
 typedef struct SHA512state_st
 	{
-	SHA_LONG64 h[8];
+	SHA_LONG64 h[8];						/* ARRAY OK 2009-05-25 yngve */
 	SHA_LONG64 Nl,Nh;
 	union {
-		SHA_LONG64	d[SHA_LBLOCK];
-		unsigned char	p[SHA512_CBLOCK];
+		SHA_LONG64	d[SHA_LBLOCK];			/* ARRAY OK 2009-05-25 yngve */
+		unsigned char	p[SHA512_CBLOCK];	/* ARRAY OK 2009-05-25 yngve */
 	} u;
 	unsigned int num,md_len;
 	} SHA512_CTX;
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha1.c openssl-1.0.0q/crypto/sha/sha1.c
--- openssl-1.0.0q.orig/crypto/sha/sha1.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha1.c	2017-04-25 16:23:40.666621872 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/sha.h>
 
 #define BUFSIZE	1024*16
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha1_one.c openssl-1.0.0q/crypto/sha/sha1_one.c
--- openssl-1.0.0q.orig/crypto/sha/sha1_one.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha1_one.c	2017-04-25 16:23:40.667620882 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/sha.h>
 #include <openssl/crypto.h>
 
@@ -65,7 +67,12 @@
 unsigned char *SHA1(const unsigned char *d, size_t n, unsigned char *md)
 	{
 	SHA_CTX c;
+#ifdef _NO_GLOBALS_
+extern unsigned char *g_sha1_m_addr();
+#define m g_sha1_m_addr()
+#else
 	static unsigned char m[SHA_DIGEST_LENGTH];
+#endif
 
 	if (md == NULL) md=m;
 	if (!SHA1_Init(&c))
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha1dgst.c openssl-1.0.0q/crypto/sha/sha1dgst.c
--- openssl-1.0.0q.orig/crypto/sha/sha1dgst.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha1dgst.c	2017-04-25 16:23:40.668621009 +0200
@@ -64,7 +64,9 @@
 
 #include <openssl/opensslv.h>
 
-const char SHA1_version[]="SHA1" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char SHA1_version[]="SHA1" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
 /* The implementation is in ../md32_common.h */
 
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha1test.c openssl-1.0.0q/crypto/sha/sha1test.c
--- openssl-1.0.0q.orig/crypto/sha/sha1test.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha1test.c	2017-04-25 16:23:40.668621009 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -113,8 +115,8 @@
 	unsigned char md[SHA_DIGEST_LENGTH];
 
 #ifdef CHARSET_EBCDIC
-	ebcdic2ascii(test[0], test[0], strlen(test[0]));
-	ebcdic2ascii(test[1], test[1], strlen(test[1]));
+	ebcdic2ascii(test[0], test[0], op_strlen(test[0]));
+	ebcdic2ascii(test[1], test[1], op_strlen(test[1]));
 #endif
 
 	EVP_MD_CTX_init(&c);
@@ -125,7 +127,7 @@
 		{
 		EVP_Digest(*P,strlen((char *)*P),md,NULL,EVP_sha1(), NULL);
 		p=pt(md);
-		if (strcmp(p,(char *)*R) != 0)
+		if (op_strcmp(p,(char *)*R) != 0)
 			{
 			printf("error calculating SHA1 on '%s'\n",*P);
 			printf("got %s instead of %s\n",p,*R);
@@ -138,7 +140,7 @@
 		P++;
 		}
 
-	memset(buf,'a',1000);
+	op_memset(buf,'a',1000);
 #ifdef CHARSET_EBCDIC
 	ebcdic2ascii(buf, buf, 1000);
 #endif /*CHARSET_EBCDIC*/
@@ -149,7 +151,7 @@
 	p=pt(md);
 
 	r=bigret;
-	if (strcmp(p,r) != 0)
+	if (op_strcmp(p,r) != 0)
 		{
 		printf("error calculating SHA1 on 'a' * 1000\n");
 		printf("got %s instead of %s\n",p,r);
@@ -172,7 +174,7 @@
 	static char buf[80];
 
 	for (i=0; i<SHA_DIGEST_LENGTH; i++)
-		sprintf(&(buf[i*2]),"%02x",md[i]);
+		op_sprintf(&(buf[i*2]),"%02x",md[i]);
 	return(buf);
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha256.c openssl-1.0.0q/crypto/sha/sha256.c
--- openssl-1.0.0q.orig/crypto/sha/sha256.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha256.c	2017-04-25 16:23:40.669621415 +0200
@@ -4,17 +4,17 @@
  * according to the OpenSSL license [found in ../../LICENSE].
  * ====================================================================
  */
+#include <openssl/cryptlib.h>
 #include <openssl/opensslconf.h>
 #if !defined(OPENSSL_NO_SHA) && !defined(OPENSSL_NO_SHA256)
 
-#include <stdlib.h>
-#include <string.h>
-
 #include <openssl/crypto.h>
 #include <openssl/sha.h>
 #include <openssl/opensslv.h>
 
-const char SHA256_version[]="SHA-256" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char SHA256_version[]="SHA-256" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
 int SHA224_Init (SHA256_CTX *c)
 	{
@@ -38,10 +38,11 @@
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 unsigned char *SHA224(const unsigned char *d, size_t n, unsigned char *md)
 	{
 	SHA256_CTX c;
-	static unsigned char m[SHA224_DIGEST_LENGTH];
+	static unsigned char m[SHA224_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	if (md == NULL) md=m;
 	SHA224_Init(&c);
@@ -54,7 +55,7 @@
 unsigned char *SHA256(const unsigned char *d, size_t n, unsigned char *md)
 	{
 	SHA256_CTX c;
-	static unsigned char m[SHA256_DIGEST_LENGTH];
+	static unsigned char m[SHA256_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	if (md == NULL) md=m;
 	SHA256_Init(&c);
@@ -68,6 +69,7 @@
 {   return SHA256_Update (c,data,len);   }
 int SHA224_Final (unsigned char *md, SHA256_CTX *c)
 {   return SHA256_Final (md,c);   }
+#endif
 
 #define	DATA_ORDER_IS_BIG_ENDIAN
 
@@ -112,7 +114,7 @@
 #endif
 void sha256_block_data_order (SHA256_CTX *ctx, const void *in, size_t num);
 
-#include "md32_common.h"
+#include <openssl/md32_common.h>
 
 #ifndef SHA256_ASM
 static const SHA_LONG K256[64] = {
@@ -153,7 +155,7 @@
 	unsigned MD32_REG_T a,b,c,d,e,f,g,h,s0,s1,T1,T2;
 	SHA_LONG	X[16],l;
 	int i;
-	const unsigned char *data=in;
+	const unsigned char *data= (const unsigned char *) in;
 
 			while (num--) {
 
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha512.c openssl-1.0.0q/crypto/sha/sha512.c
--- openssl-1.0.0q.orig/crypto/sha/sha512.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha512.c	2017-04-25 16:23:40.670620983 +0200
@@ -4,6 +4,7 @@
  * according to the OpenSSL license [found in ../../LICENSE].
  * ====================================================================
  */
+#include <openssl/cryptlib.h>
 #include <openssl/opensslconf.h>
 #if !defined(OPENSSL_NO_SHA) && !defined(OPENSSL_NO_SHA512)
 /*
@@ -41,16 +42,16 @@
  * 16-bit platforms.
  *					<appro@fy.chalmers.se>
  */
-#include <stdlib.h>
-#include <string.h>
 
 #include <openssl/crypto.h>
 #include <openssl/sha.h>
 #include <openssl/opensslv.h>
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 
-const char SHA512_version[]="SHA-512" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char SHA512_version[]="SHA-512" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
 #if defined(__i386) || defined(__i386__) || defined(_M_IX86) || \
     defined(__x86_64) || defined(_M_AMD64) || defined(_M_X64) || \
@@ -130,10 +131,10 @@
 	p[n]=0x80;	/* There always is a room for one */
 	n++;
 	if (n > (sizeof(c->u)-16))
-		memset (p+n,0,sizeof(c->u)-n), n=0,
+		op_memset (p+n,0,sizeof(c->u)-n), n=0,
 		sha512_block_data_order (c,p,1);
 
-	memset (p+n,0,sizeof(c->u)-16-n);
+	op_memset (p+n,0,sizeof(c->u)-16-n);
 #ifdef	B_ENDIAN
 	c->u.d[SHA_LBLOCK-2] = c->Nh;
 	c->u.d[SHA_LBLOCK-1] = c->Nl;
@@ -218,8 +219,10 @@
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int SHA384_Final (unsigned char *md,SHA512_CTX *c)
 {   return SHA512_Final (md,c);   }
+#endif
 
 int SHA512_Update (SHA512_CTX *c, const void *_data, size_t len)
 	{
@@ -244,7 +247,7 @@
 			return 1;
 			}
 		else	{
-			memcpy (p+c->num,data,n), c->num = 0;
+			op_memcpy (p+c->num,data,n), c->num = 0;
 			len-=n, data+=n;
 			sha512_block_data_order (c,p,1);
 			}
@@ -255,7 +258,7 @@
 #ifndef SHA512_BLOCK_CAN_MANAGE_UNALIGNED_DATA
 		if ((size_t)data%sizeof(c->u.d[0]) != 0)
 			while (len >= sizeof(c->u))
-				memcpy (p,data,sizeof(c->u)),
+				op_memcpy (p,data,sizeof(c->u)),
 				sha512_block_data_order (c,p,1),
 				len  -= sizeof(c->u),
 				data += sizeof(c->u);
@@ -267,11 +270,12 @@
 			data -= len;
 		}
 
-	if (len != 0)	memcpy (p,data,len), c->num = (int)len;
+	if (len != 0)	op_memcpy (p,data,len), c->num = (int)len;
 
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int SHA384_Update (SHA512_CTX *c, const void *data, size_t len)
 {   return SHA512_Update (c,data,len);   }
 
@@ -281,7 +285,7 @@
 unsigned char *SHA384(const unsigned char *d, size_t n, unsigned char *md)
 	{
 	SHA512_CTX c;
-	static unsigned char m[SHA384_DIGEST_LENGTH];
+	static unsigned char m[SHA384_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	if (md == NULL) md=m;
 	SHA384_Init(&c);
@@ -294,7 +298,7 @@
 unsigned char *SHA512(const unsigned char *d, size_t n, unsigned char *md)
 	{
 	SHA512_CTX c;
-	static unsigned char m[SHA512_DIGEST_LENGTH];
+	static unsigned char m[SHA512_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	if (md == NULL) md=m;
 	SHA512_Init(&c);
@@ -303,6 +307,7 @@
 	OPENSSL_cleanse(&c,sizeof(c));
 	return(md);
 	}
+#endif
 
 #ifndef SHA512_ASM
 static const SHA_LONG64 K512[80] = {
@@ -392,6 +397,8 @@
 #  endif
 #  if defined(_M_IX86) && !defined(OPENSSL_NO_ASM) && !defined(OPENSSL_NO_INLINE_ASM)
 #   if defined(I386_ONLY)
+#	pragma warning(push)
+#   pragma warning(disable: 4035)
     static SHA_LONG64 __fastcall __pull64be(const void *x)
     {	_asm	mov	edx, [ecx + 0]
 	_asm	mov	eax, [ecx + 4]
@@ -402,13 +409,17 @@
 	_asm	xchg	dh,dl
 	_asm	xchg	ah,al
     }
+#	pragma warning(pop)
 #   else
+#	pragma warning(push)
+#   pragma warning(disable: 4035)
     static SHA_LONG64 __fastcall __pull64be(const void *x)
     {	_asm	mov	edx, [ecx + 0]
 	_asm	mov	eax, [ecx + 4]
 	_asm	bswap	edx
 	_asm	bswap	eax
     }
+#	pragma warning(pop)
 #   endif
 #   define PULL64(x) __pull64be(&(x))
 #   if _MSC_VER<=1200
@@ -443,7 +454,7 @@
  */
 static void sha512_block_data_order (SHA512_CTX *ctx, const void *in, size_t num)
 	{
-	const SHA_LONG64 *W=in;
+	const SHA_LONG64 *W=(const SHA_LONG64 *)in;
 	SHA_LONG64	A,E,T;
 	SHA_LONG64	X[9+80],*F;
 	int i;
@@ -498,7 +509,7 @@
 
 static void sha512_block_data_order (SHA512_CTX *ctx, const void *in, size_t num)
 	{
-	const SHA_LONG64 *W=in;
+	const SHA_LONG64 *W= (const SHA_LONG64 *) in;
 	SHA_LONG64	a,b,c,d,e,f,g,h,s0,s1,T1,T2;
 	SHA_LONG64	X[16];
 	int i;
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha512t.c openssl-1.0.0q/crypto/sha/sha512t.c
--- openssl-1.0.0q.orig/crypto/sha/sha512t.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha512t.c	2017-04-25 16:23:40.671621669 +0200
@@ -81,7 +81,7 @@
 #ifdef OPENSSL_IA32_SSE2
     /* Alternative to this is to call OpenSSL_add_all_algorithms...
      * The below code is retained exclusively for debugging purposes. */
-    { char      *env;
+    { const char      *env;
 
 	if ((env=getenv("OPENSSL_ia32cap")))
 	    OPENSSL_ia32cap = strtoul (env,NULL,0);
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha_locl.h openssl-1.0.0q/crypto/sha/sha_locl.h
--- openssl-1.0.0q.orig/crypto/sha/sha_locl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha_locl.h	2017-04-25 16:23:40.672620958 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/opensslconf.h>
 #include <openssl/sha.h>
@@ -114,7 +116,7 @@
 # error "Either SHA_0 or SHA_1 must be defined."
 #endif
 
-#include "md32_common.h"
+#include <openssl/md32_common.h>
 
 #define INIT_DATA_h0 0x67452301UL
 #define INIT_DATA_h1 0xefcdab89UL
@@ -207,7 +209,7 @@
 #if !defined(SHA_1) || !defined(SHA1_ASM)
 static void HASH_BLOCK_DATA_ORDER (SHA_CTX *c, const void *p, size_t num)
 	{
-	const unsigned char *data=p;
+	const unsigned char *data=static_cast<const unsigned char*>(p);
 	register unsigned MD32_REG_T A,B,C,D,E,T,l;
 #ifndef MD32_XARRAY
 	unsigned MD32_REG_T	XX0, XX1, XX2, XX3, XX4, XX5, XX6, XX7,
@@ -392,7 +394,7 @@
 #if !defined(SHA_1) || !defined(SHA1_ASM)
 static void HASH_BLOCK_DATA_ORDER (SHA_CTX *c, const void *p, size_t num)
 	{
-	const unsigned char *data=p;
+	const unsigned char *data= (const unsigned char *) p;
 	register unsigned MD32_REG_T A,B,C,D,E,T,l;
 	int i;
 	SHA_LONG	X[16];
diff -Naur openssl-1.0.0q.orig/crypto/sha/sha_one.c openssl-1.0.0q/crypto/sha/sha_one.c
--- openssl-1.0.0q.orig/crypto/sha/sha_one.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/sha_one.c	2017-04-25 16:23:40.673621644 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/sha.h>
 #include <openssl/crypto.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/sha/shatest.c openssl-1.0.0q/crypto/sha/shatest.c
--- openssl-1.0.0q.orig/crypto/sha/shatest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/sha/shatest.c	2017-04-25 16:23:40.674621212 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -113,8 +115,8 @@
 	unsigned char md[SHA_DIGEST_LENGTH];
 
 #ifdef CHARSET_EBCDIC
-	ebcdic2ascii(test[0], test[0], strlen(test[0]));
-	ebcdic2ascii(test[1], test[1], strlen(test[1]));
+	ebcdic2ascii(test[0], test[0], op_strlen(test[0]));
+	ebcdic2ascii(test[1], test[1], op_strlen(test[1]));
 #endif
 
 	EVP_MD_CTX_init(&c);
@@ -138,7 +140,7 @@
 		P++;
 		}
 
-	memset(buf,'a',1000);
+	op_memset(buf,'a',1000);
 #ifdef CHARSET_EBCDIC
 	ebcdic2ascii(buf, buf, 1000);
 #endif /*CHARSET_EBCDIC*/
@@ -149,7 +151,7 @@
 	p=pt(md);
 
 	r=bigret;
-	if (strcmp(p,r) != 0)
+	if (op_strcmp(p,r) != 0)
 		{
 		printf("error calculating SHA on '%s'\n",p);
 		printf("got %s instead of %s\n",p,r);
@@ -172,7 +174,7 @@
 	static char buf[80];
 
 	for (i=0; i<SHA_DIGEST_LENGTH; i++)
-		sprintf(&(buf[i*2]),"%02x",md[i]);
+		op_sprintf(&(buf[i*2]),"%02x",md[i]);
 	return(buf);
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/stack/.gitignore openssl-1.0.0q/crypto/stack/.gitignore
--- openssl-1.0.0q.orig/crypto/stack/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/stack/.gitignore	2017-04-25 16:23:40.675621340 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/stack/stack.c openssl-1.0.0q/crypto/stack/stack.c
--- openssl-1.0.0q.orig/crypto/stack/stack.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/stack/stack.c	2017-04-25 16:23:40.676620908 +0200
@@ -65,17 +65,23 @@
  *
  * 1.0 eay - First version 29/07/92
  */
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/stack.h>
 #include <openssl/objects.h>
 
 #undef MIN_NODES
 #define MIN_NODES	4
 
-const char STACK_version[]="Stack" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char STACK_version[]="Stack" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 int (*sk_set_cmp_func(_STACK *sk, int (*c)(const void *, const void *)))
 		(const void *, const void *)
@@ -101,7 +107,7 @@
 	ret->data=s;
 
 	ret->num=sk->num;
-	memcpy(ret->data,sk->data,sizeof(char *)*sk->num);
+	op_memcpy(ret->data,sk->data,sizeof(char *)*sk->num);
 	ret->sorted=sk->sorted;
 	ret->num_alloc=sk->num_alloc;
 	ret->comp=sk->comp;
@@ -122,9 +128,9 @@
 	_STACK *ret;
 	int i;
 
-	if ((ret=OPENSSL_malloc(sizeof(_STACK))) == NULL)
+	if ((ret=(_STACK *)OPENSSL_malloc(sizeof(_STACK))) == NULL)
 		goto err;
-	if ((ret->data=OPENSSL_malloc(sizeof(char *)*MIN_NODES)) == NULL)
+	if ((ret->data=(char **)OPENSSL_malloc(sizeof(char *)*MIN_NODES)) == NULL)
 		goto err;
 	for (i=0; i<MIN_NODES; i++)
 		ret->data[i]=NULL;
@@ -146,7 +152,7 @@
 	if(st == NULL) return 0;
 	if (st->num_alloc <= st->num+1)
 		{
-		s=OPENSSL_realloc((char *)st->data,
+		s=(char **)OPENSSL_realloc((char *)st->data,
 			(unsigned int)sizeof(char *)*st->num_alloc*2);
 		if (s == NULL)
 			return(0);
@@ -154,7 +160,7 @@
 		st->num_alloc*=2;
 		}
 	if ((loc >= (int)st->num) || (loc < 0))
-		st->data[st->num]=data;
+		st->data[st->num]=(char *)data;
 	else
 		{
 		int i;
@@ -170,7 +176,7 @@
 			&(st->data[loc]),
 			sizeof(char *)*(st->num-loc));
 #endif
-		st->data[loc]=data;
+		st->data[loc]=(char *)data;
 		}
 	st->num++;
 	st->sorted=0;
@@ -201,7 +207,7 @@
 		for (i=loc; i<j; i++)
 			st->data[i]=st->data[i+1];
 		/* In theory memcpy is not safe for this
-		 * memcpy( &(st->data[loc]),
+		 * op_memcpy( &(st->data[loc]),
 		 *	&(st->data[loc+1]),
 		 *	sizeof(char *)*(st->num-loc-1));
 		 */
@@ -212,7 +218,7 @@
 
 static int internal_find(_STACK *st, void *data, int ret_val_options)
 	{
-	const void * const *r;
+	const void *r;
 	int i;
 
 	if(st == NULL) return -1;
@@ -236,16 +242,20 @@
 	{
 	return internal_find(st, data, OBJ_BSEARCH_FIRST_VALUE_ON_MATCH);
 	}
+
+#ifndef OPERA_SMALL_VERSION
 int sk_find_ex(_STACK *st, void *data)
 	{
 	return internal_find(st, data, OBJ_BSEARCH_VALUE_ON_NOMATCH);
 	}
+#endif
 
 int sk_push(_STACK *st, void *data)
 	{
 	return(sk_insert(st,data,st->num));
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int sk_unshift(_STACK *st, void *data)
 	{
 	return(sk_insert(st,data,0));
@@ -257,6 +267,7 @@
 	if (st->num <= 0) return(NULL);
 	return(sk_delete(st,0));
 	}
+#endif
 
 void *sk_pop(_STACK *st)
 	{
@@ -269,7 +280,7 @@
 	{
 	if (st == NULL) return;
 	if (st->num <= 0) return;
-	memset((char *)st->data,0,sizeof(st->data)*st->num);
+	op_memset((char *)st->data,0,sizeof(st->data)*st->num);
 	st->num=0;
 	}
 
@@ -306,7 +317,7 @@
 void *sk_set(_STACK *st, int i, void *value)
 {
 	if(!st || (i < 0) || (i >= st->num)) return NULL;
-	return (st->data[i] = value);
+	return (st->data[i] = (char*)value);
 }
 
 void sk_sort(_STACK *st)
@@ -321,7 +332,7 @@
 		 * type** with type**, so we leave the casting until absolutely
 		 * necessary (ie. "now"). */
 		comp_func=(int (*)(const void *,const void *))(st->comp);
-		qsort(st->data,st->num,sizeof(char *), comp_func);
+		op_qsort(st->data,st->num,sizeof(char *), comp_func);
 		st->sorted=1;
 		}
 	}
diff -Naur openssl-1.0.0q.orig/crypto/store/.gitignore openssl-1.0.0q/crypto/store/.gitignore
--- openssl-1.0.0q.orig/crypto/store/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/store/.gitignore	2017-04-25 16:23:40.676620908 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/store/store.h openssl-1.0.0q/crypto/store/store.h
--- openssl-1.0.0q.orig/crypto/store/store.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/store/store.h	2017-04-25 16:23:40.677620477 +0200
@@ -205,7 +205,7 @@
 	} STORE_CERTIFICATE_STATUS;
 
 /* Engine store functions will return a structure that contains all the necessary
- * information, including revokation status for certificates.  This is really not
+ * information, including revocation status for certificates.  This is really not
  * needed for application authors, as the ENGINE framework functions will extract
  * the OpenSSL-specific information when at all possible.  However, for engine
  * authors, it's crucial to know this structure.  */
diff -Naur openssl-1.0.0q.orig/crypto/threads/.gitignore openssl-1.0.0q/crypto/threads/.gitignore
--- openssl-1.0.0q.orig/crypto/threads/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/threads/.gitignore	2017-04-25 16:23:40.678621162 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/threads/mttest.c openssl-1.0.0q/crypto/threads/mttest.c
--- openssl-1.0.0q.orig/crypto/threads/mttest.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/threads/mttest.c	2017-04-25 16:23:40.679620451 +0200
@@ -56,15 +56,22 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifdef LINUX
 #include <typedefs.h>
 #endif
 #ifdef OPENSSL_SYS_WIN32
+#ifndef OPERA_SMALL_VERSION
 #include <windows.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef SOLARIS
 #include <synch.h>
@@ -134,7 +141,7 @@
 BIO *bio_err=NULL;
 BIO *bio_stdout=NULL;
 
-static char *cipher=NULL;
+static const char *cipher=NULL;
 int verbose=0;
 #ifdef FIONBIO
 static int s_nbio=0;
@@ -207,50 +214,50 @@
 
 	while (argc >= 1)
 		{
-		if	(strcmp(*argv,"-server_auth") == 0)
+		if	(op_strcmp(*argv,"-server_auth") == 0)
 			server_auth=1;
-		else if	(strcmp(*argv,"-client_auth") == 0)
+		else if	(op_strcmp(*argv,"-client_auth") == 0)
 			client_auth=1;
-		else if	(strcmp(*argv,"-reconnect") == 0)
+		else if	(op_strcmp(*argv,"-reconnect") == 0)
 			reconnect=1;
-		else if	(strcmp(*argv,"-stats") == 0)
+		else if	(op_strcmp(*argv,"-stats") == 0)
 			cache_stats=1;
-		else if	(strcmp(*argv,"-ssl3") == 0)
+		else if	(op_strcmp(*argv,"-ssl3") == 0)
 			ssl_method=SSLv3_method();
-		else if	(strcmp(*argv,"-ssl2") == 0)
+		else if	(op_strcmp(*argv,"-ssl2") == 0)
 			ssl_method=SSLv2_method();
-		else if	(strcmp(*argv,"-CApath") == 0)
+		else if	(op_strcmp(*argv,"-CApath") == 0)
 			{
 			if (--argc < 1) goto bad;
 			CApath= *(++argv);
 			}
-		else if	(strcmp(*argv,"-CAfile") == 0)
+		else if	(op_strcmp(*argv,"-CAfile") == 0)
 			{
 			if (--argc < 1) goto bad;
 			CAfile= *(++argv);
 			}
-		else if	(strcmp(*argv,"-cert") == 0)
+		else if	(op_strcmp(*argv,"-cert") == 0)
 			{
 			if (--argc < 1) goto bad;
 			scert= *(++argv);
 			}
-		else if	(strcmp(*argv,"-ccert") == 0)
+		else if	(op_strcmp(*argv,"-ccert") == 0)
 			{
 			if (--argc < 1) goto bad;
 			ccert= *(++argv);
 			}
-		else if	(strcmp(*argv,"-threads") == 0)
+		else if	(op_strcmp(*argv,"-threads") == 0)
 			{
 			if (--argc < 1) goto bad;
-			thread_number= atoi(*(++argv));
+			thread_number= op_atoi(*(++argv));
 			if (thread_number == 0) thread_number=1;
 			if (thread_number > MAX_THREAD_NUMBER)
 				thread_number=MAX_THREAD_NUMBER;
 			}
-		else if	(strcmp(*argv,"-loops") == 0)
+		else if	(op_strcmp(*argv,"-loops") == 0)
 			{
 			if (--argc < 1) goto bad;
-			number_of_loops= atoi(*(++argv));
+			number_of_loops= op_atoi(*(++argv));
 			if (number_of_loops == 0) number_of_loops=1;
 			}
 		else
@@ -669,7 +676,7 @@
 #endif
 err:
 	/* We have to set the BIO's to NULL otherwise they will be
-	 * free()ed twice.  Once when th s_ssl is SSL_free()ed and
+	 * op_free()ed twice.  Once when th s_ssl is SSL_free()ed and
 	 * again when c_ssl is SSL_free()ed.
 	 * This is a hack required because s_ssl and c_ssl are sharing the same
 	 * BIO structure and SSL_set_bio() and SSL_free() automatically
@@ -937,7 +944,7 @@
 	int i;
 	char filename[20];
 
-	strcpy(filename,"/tmp/mttest.XXXXXX");
+	op_strcpy(filename,"/tmp/mttest.XXXXXX");
 	mktemp(filename);
 
 	usconfig(CONF_STHREADIOOFF);
@@ -966,7 +973,7 @@
 		{
 		char buf[10];
 
-		sprintf(buf,"%2d:",i);
+		op_sprintf(buf,"%2d:",i);
 		usdumpsema(lock_cs[i],stdout,buf);
 		usfreesema(lock_cs[i],arena);
 		}
diff -Naur openssl-1.0.0q.orig/crypto/threads/th-lock.c openssl-1.0.0q/crypto/threads/th-lock.c
--- openssl-1.0.0q.orig/crypto/threads/th-lock.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/threads/th-lock.c	2017-04-25 16:23:40.680620858 +0200
@@ -56,15 +56,22 @@
  * [including the GNU Public Licence.]
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifdef LINUX
 #include <typedefs.h>
 #endif
 #ifdef OPENSSL_SYS_WIN32
+#ifndef OPERA_SMALL_VERSION
 #include <windows.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef SOLARIS
 #include <synch.h>
@@ -257,7 +264,7 @@
 	int i;
 	char filename[20];
 
-	strcpy(filename,"/tmp/mttest.XXXXXX");
+	op_strcpy(filename,"/tmp/mttest.XXXXXX");
 	mktemp(filename);
 
 	usconfig(CONF_STHREADIOOFF);
@@ -286,7 +293,7 @@
 		{
 		char buf[10];
 
-		sprintf(buf,"%2d:",i);
+		op_sprintf(buf,"%2d:",i);
 		usdumpsema(lock_cs[i],stdout,buf);
 		usfreesema(lock_cs[i],arena);
 		}
diff -Naur openssl-1.0.0q.orig/crypto/txt_db/.gitignore openssl-1.0.0q/crypto/txt_db/.gitignore
--- openssl-1.0.0q.orig/crypto/txt_db/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/txt_db/.gitignore	2017-04-25 16:23:40.681620706 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/txt_db/txt_db.c openssl-1.0.0q/crypto/txt_db/txt_db.c
--- openssl-1.0.0q.orig/crypto/txt_db/txt_db.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/txt_db/txt_db.c	2017-04-25 16:23:40.681620706 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 #include <openssl/txt_db.h>
@@ -66,7 +68,9 @@
 #undef BUFSIZE
 #define BUFSIZE	512
 
-const char TXT_DB_version[]="TXT_DB" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char TXT_DB_version[]="TXT_DB" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
 TXT_DB *TXT_DB_read(BIO *in, int num)
 	{
@@ -116,7 +120,7 @@
 		ln++;
 		if (buf->data[offset] == '\0') break;
 		if ((offset == 0) && (buf->data[0] == '#')) continue;
-		i=strlen(&(buf->data[offset]));
+		i=op_strlen(&(buf->data[offset]));
 		offset+=i;
 		if (buf->data[offset-1] != '\n')
 			continue;
@@ -271,7 +275,7 @@
 		for (j=0; j<nn; j++)
 			{
 			if (pp[j] != NULL)
-				l+=strlen(pp[j]);
+				l+=op_strlen(pp[j]);
 			}
 		if (!BUF_MEM_grow_clean(buf,(int)(l*2+nn))) goto err;
 
diff -Naur openssl-1.0.0q.orig/crypto/ui/.gitignore openssl-1.0.0q/crypto/ui/.gitignore
--- openssl-1.0.0q.orig/crypto/ui/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/ui/.gitignore	2017-04-25 16:23:40.682621950 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/ui/ui_compat.c openssl-1.0.0q/crypto/ui/ui_compat.c
--- openssl-1.0.0q.orig/crypto/ui/ui_compat.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ui/ui_compat.c	2017-04-25 16:23:40.683621239 +0200
@@ -53,7 +53,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/ui_compat.h>
 
 int _ossl_old_des_read_pw_string(char *buf,int length,const char *prompt,int verify)
diff -Naur openssl-1.0.0q.orig/crypto/ui/ui_err.c openssl-1.0.0q/crypto/ui/ui_err.c
--- openssl-1.0.0q.orig/crypto/ui/ui_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ui/ui_err.c	2017-04-25 16:23:40.683621239 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/ui.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/ui/ui_lib.c openssl-1.0.0q/crypto/ui/ui_lib.c
--- openssl-1.0.0q.orig/crypto/ui/ui_lib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ui/ui_lib.c	2017-04-25 16:23:40.684621925 +0200
@@ -56,8 +56,13 @@
  *
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/e_os2.h>
 #include <openssl/buffer.h>
 #include <openssl/ui.h>
@@ -209,7 +214,7 @@
 		{
 		for(p = ok_chars; *p; p++)
 			{
-			if (strchr(cancel_chars, *p))
+			if (op_strchr(cancel_chars, *p))
 				{
 				UIerr(UI_F_GENERAL_ALLOCATE_BOOLEAN,
 					UI_R_COMMON_OK_AND_CANCEL_CHARACTERS);
@@ -425,9 +430,9 @@
 
 		if (object_desc == NULL)
 			return NULL;
-		len = sizeof(prompt1) - 1 + strlen(object_desc);
+		len = sizeof(prompt1) - 1 + op_strlen(object_desc);
 		if (object_name)
-			len += sizeof(prompt2) - 1 + strlen(object_name);
+			len += sizeof(prompt2) - 1 + op_strlen(object_name);
 		len += sizeof(prompt3) - 1;
 
 		prompt = (char *)OPENSSL_malloc(len + 1);
@@ -474,7 +479,7 @@
 	{
 	UI_STRING uis;
 
-	memset(&uis, 0, sizeof(uis));
+	op_memset(&uis, 0, sizeof(uis));
 	uis.type = UIT_ERROR;
 	uis.out_string = str;
 
@@ -844,7 +849,7 @@
 
 int UI_set_result(UI *ui, UI_STRING *uis, const char *result)
 	{
-	int l = strlen(result);
+	int l = op_strlen(result);
 
 	ui->flags &= ~UI_FLAG_REDOABLE;
 
@@ -903,13 +908,13 @@
 		uis->result_buf[0] = '\0';
 		for(p = result; *p; p++)
 			{
-			if (strchr(uis->_.boolean_data.ok_chars, *p))
+			if (op_strchr(uis->_.boolean_data.ok_chars, *p))
 				{
 				uis->result_buf[0] =
 					uis->_.boolean_data.ok_chars[0];
 				break;
 				}
-			if (strchr(uis->_.boolean_data.cancel_chars, *p))
+			if (op_strchr(uis->_.boolean_data.cancel_chars, *p))
 				{
 				uis->result_buf[0] =
 					uis->_.boolean_data.cancel_chars[0];
diff -Naur openssl-1.0.0q.orig/crypto/ui/ui_openssl.c openssl-1.0.0q/crypto/ui/ui_openssl.c
--- openssl-1.0.0q.orig/crypto/ui/ui_openssl.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ui/ui_openssl.c	2017-04-25 16:23:40.685620376 +0200
@@ -114,6 +114,9 @@
  * [including the GNU Public Licence.]
  */
 
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+
 
 #include <openssl/e_os2.h>
 
@@ -157,7 +160,7 @@
 
 /* 06-Apr-92 Luke Brennan    Support for VMS */
 #include "ui_locl.h"
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 
 #ifdef OPENSSL_SYS_VMS		/* prototypes for sys$whatever */
 # include <starlet.h>
@@ -167,7 +170,9 @@
 #endif
 
 #ifdef WIN_CONSOLE_BUG
+#ifndef OPERA_SMALL_VERSION
 # include <windows.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifndef OPENSSL_SYS_WINCE
 # include <wincon.h>
 #endif
@@ -375,7 +380,7 @@
 		if ((ok = read_string_inner(ui, uis,
 			UI_get_input_flags(uis) & UI_INPUT_FLAG_ECHO, 1)) <= 0)
 			return ok;
-		if (strcmp(UI_get0_result_string(uis),
+		if (op_strcmp(UI_get0_result_string(uis),
 			UI_get0_test_string(uis)) != 0)
 			{
 			fprintf(tty_out,"Verify failure\n");
@@ -525,7 +530,7 @@
 static int noecho_console(UI *ui)
 	{
 #ifdef TTY_FLAGS
-	memcpy(&(tty_new),&(tty_orig),sizeof(tty_orig));
+	op_memcpy(&(tty_new),&(tty_orig),sizeof(tty_orig));
 	tty_new.TTY_FLAGS &= ~ECHO;
 #endif
 
@@ -547,7 +552,7 @@
 static int echo_console(UI *ui)
 	{
 #if defined(TTY_set) && !defined(OPENSSL_SYS_VMS)
-	memcpy(&(tty_new),&(tty_orig),sizeof(tty_orig));
+	op_memcpy(&(tty_new),&(tty_orig),sizeof(tty_orig));
 	tty_new.TTY_FLAGS |= ECHO;
 #endif
 
@@ -589,7 +594,7 @@
 #ifdef SIGACTION
 	struct sigaction sa;
 
-	memset(&sa,0,sizeof sa);
+	op_memset(&sa,0,sizeof sa);
 	sa.sa_handler=recsig;
 #endif
 
@@ -707,6 +712,6 @@
 			FlushConsoleInputBuffer(inh);
 		}
 #endif
-	return(strlen(buf));
+	return(op_strlen(buf));
 	}
 #endif
